#include <Windows.h>
#include <tchar.h>

#include "direct3d.h" 
#include "texture.h"
#include "sprite.h"


// EBhEvV[WAEBhEɑ΂郁bZ[Ws
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	
	switch(msg){
		// EBhEjꂽƂ
	case WM_DESTROY:
		PostQuitMessage(0);	// WM_QUITbZ[WbZ[WL[ɑ
		return 0;
	}
	// ftHg̃bZ[Ws
	return DefWindowProc(hWnd, msg, wParam, lParam);
}

// WinMain֐iAvP[V̊Jn֐j
// R\[AvP[VƈႢAR\[JȂ
int _stdcall WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	const TCHAR* WC_BASIC = _T("BASIC_WINDOW");
	// VvEBhENXݒ
	WNDCLASSEX wcex ={sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS,WndProc, 0,0,hInstance,
		(HICON)LoadImage(NULL,MAKEINTRESOURCE(IDI_APPLICATION),IMAGE_ICON,0,0,LR_DEFAULTSIZE | LR_SHARED),
		(HCURSOR)LoadImage(NULL,MAKEINTRESOURCE(IDC_ARROW),IMAGE_CURSOR,0,0,LR_DEFAULTSIZE | LR_SHARED), 
		(HBRUSH)GetStockObject(WHITE_BRUSH), NULL, WC_BASIC , NULL};

	// VvEBhENX쐬
	if(!RegisterClassEx(&wcex)) 
		return false;

	// EBhEA̓fBXvCɈˑBʂ4:3
	const int WINDOW_WIDTH = 640;
	const int WINDOW_HEIGHT = 480;
	// EBhE̍쐬
	HWND hWnd = CreateWindowEx(0,WC_BASIC,
		_T("Application"), WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
		CW_USEDEFAULT,CW_USEDEFAULT,WINDOW_WIDTH,WINDOW_HEIGHT,NULL,NULL,hInstance,NULL);

///////////////////////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////
	//	Direct3D̏
	////////////////////////////////////
	Direct3D direct3d;
	direct3d.Create(hWnd,WINDOW_WIDTH,WINDOW_HEIGHT);

	////////////////////////////////
	// eNX`쐬
	////////////////////////////////
	Texture cartex;
	cartex.Load(direct3d.pDevice3D,_T("car.bmp"));


	////////////////////////////////
	// XvCg쐬
	////////////////////////////////
	Sprite sprite;

	sprite.SetPos(200,200);
	sprite.SetWidth(128,128);
	sprite.SetRotate(D3DX_PI/4.0f);

///////////////////////////////////////////////////////////////////////////////////////////////
		
	// bZ[W[v
	MSG msg = {}; 
	while(msg.message != WM_QUIT) {
		// AvP[VɑĂ郁bZ[WbZ[WL[擾
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			DispatchMessage(&msg);	// AvP[V̊eEBhEvV[WɃbZ[W]
		}
		// bZ[WĂȂƂ
		else{
			//iDirectX̏j

///////////////////////////////////////////////////////////////////////////////////////////////

			// `Jn
			if(SUCCEEDED(direct3d.pDevice3D->BeginScene()))
			{
				DWORD ClearColor = 0xff808080;	// wiNAF
				// wiNA
				direct3d.pDevice3D->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_STENCIL | D3DCLEAR_ZBUFFER, ClearColor, 1.0f, 0 );
		

				// XvCg`
				sprite.Draw(direct3d.pDevice3D,cartex.pTexture);
			
				// `I
				direct3d.pDevice3D->EndScene();
			}
			// `攽f
			direct3d.pDevice3D->Present( NULL, NULL, NULL, NULL );

///////////////////////////////////////////////////////////////////////////////////////////////
		}
	}

	
	return 0;
}